<?php  																														require_once($_SERVER['DOCUMENT_ROOT'] . "/eclipse.org-common/system/app.class.php");	require_once($_SERVER['DOCUMENT_ROOT'] . "/eclipse.org-common/system/nav.class.php"); 	require_once($_SERVER['DOCUMENT_ROOT'] . "/eclipse.org-common/system/menu.class.php"); 	$App 	= new App();	$Nav	= new Nav();	$Menu 	= new Menu();		include($App->getProjectCommon());    # All on the same line to unclutter the user's desktop'

$pageTitle 		= "PMF Component Proposal";
$pageKeywords	= "BPMN2";
$pageAuthor		= "Yves YANG";

ob_start();
?>
    <div id="maincontent">
	<div id="midcolumn">

<h1>MDT PMF</h1>
</p>
<?php
include_once($_SERVER['DOCUMENT_ROOT'] . "/projects/fragments/proposal-page-header.php");
generate_header("BPMN2");
?>

<h2>Introduction</h2>

<p>PMF (Presentation Modeling Framework) is a proposed open source component of the <a href="http://www.eclipse.org/modeling/mdt/">Model Development Tools (MDT)</a> subproject to provide a metamodel for UI modeling.</p>

<p>This component is in the Pre-Proposal Phase (as defined in the <a href="http://www.eclipse.org/projects/dev_process/development_process.php">Eclipse Development Process</a>) and this document is written to declare its intent and scope. This proposal is written to solicit additional participation and input from the Eclipse community. You are invited to comment on and/or join in the development of the component. Please send all feedback to the <a href="news://news.eclipse.org/eclipse.modeling.mdt">eclipse.modeling.mdt</a> newsgroup.</p>

<h2>Background</h2>

<p> The Graphical User Interface (GUI) is the visible part of the software.  It  really consists of the gate through which business features are made  available and it reflects the application quality. Designing the visual composition and temporal behavior of GUI is an important part of software application programming. Its goal is to enhance the efficiency and ease of use for the underlying logical design. Typically, the user interacts with information by manipulating visual widgets that allow for interactions appropriate to the kind of data they hold.  The widgets of a well-designed interface are selected to support the  actions necessary to achieve the goals of the user.</p>
<p>Model-Driven Engineering is a modern, standard and industry software engineering. It refers to a range of development approaches that are based on the use of software modeling as a primary form of expression. Sometimes models are constructed to a  certain level of detail, and then code is written by hand in a separate  step. Sometimes complete models are built including executable actions. Model-driven architecture supports model-driven engneering of software systems. MDA provides a set of guidelines for structuring specifications expressed as models. The MDA approach defines system functionality using a platform-independent model (PIM) using an appropriate domain-specific language (DSL). </p>
<p>Obviousely, MDE  in GUI needs an appropriate DSL It is in fact a critical component in  scalable enterprise data presentation applications such as ERP and BPMS in Manufacturing, Supply Chain, Financials, Customer Relationship Management (CRM), Human Resources, Warehouse Management and Decision Support System.</p>
<p>Unfortunately, an industry-adopted standard GUI DSL doesn't exist in OMG. The Advancement of Structured Information Standards (OASIS) has a project <a href="http://www.uiml.org/">UIML</a> on this domain. But this project deals with only the low level UI markup language  as XUL and XAML, and it stops giving sign of life since 2004.</p>
<p>From  users' perspective, the UI modeling is composed of following steps:</p>
<ul>
  <li>Business modeling</li>
  <li>Importation of the business model and initialization of the UI DSL structure</li>
  <li>UI modeling in UI DSL editor</li>
  <li>Model transformation from UI DSL model to  displaying technology  execution code</li>
</ul>
<p><img src="architecture.png" width="986" height="618" /></p>
<p>PMF focuses in fact on high level modeling concepts on GUI by ignoring the displaying technology artifacts such as appearence, layouts and data binding support. It allows each technology to make its specific implementation. The reference implementation will use a simple UI model based on EMF for SWT. </p>
<h2>Scope</h2>
<p>The purpose of this framework is to provide a common infrastructure by implementing the most used presentation patterns in RCP and Web applications. Each displaying technology such as SWT, Swing, JSF, GWT, Ajax or others, can extend this framework to implement a specific generator that could produces the exectable codes in java or in declarative language.</p>
<p>Precisely, PMF provides following components:</p>
<ul>

  <li>an EMF-based foundation that covers mainly the data binding modeling and presentation patterns</li>
  <li> an implementation of most presentation patterns like Page controller, Front controller, Master/Detail pattern etc.</li>
  <li>a set of  extensible tools to make UI modeling easy such as data binding editor, scenario builder etc.</li>
  <li>a base for future OMG GUI modeling specification </li>
  </ul>

<h2>Relationship with Other Eclipse Projects/Components</h2>

<p>PMF will use the most Eclipse tools to archive the UI modeling and code generation. The most important tool is the modeling transformation engine. Several engines are used in diffferent Eclipse projects:</p>
<ul>
  <li><a href="http://www.eclipse.org/emft/projects/jet">JET</a>, a  derivative of JavaServer Pages (JSP) initially developed as part of the  Eclipse Modeling Framework (EMF), and currently an incubator project <a href="http://www.eclipse.org/modeling/m2t/?project=jet">JET2</a> in  the Eclipse Modeling Project.</li>
  <li>XPand, the template language that is part of <a href="http://www.eclipse.org/gmt/oaw/">openArchitectureWare</a>.</li>
  </ul>
<p>The support of which template engine isn't yet defined. Obvious integrations between PMF and other Eclipse components (EcoreTools, UMLTools, M2T, EMF, EMFT, VE etc) will be explored as the component evolves.</p>
<h2>Organization</h2>

<h3>Initial Committers</h3>

The initial committers for this component would be:

<ul>

<li>Yves Yang (<a href="http://www.soyatec.com/">Soyatec</a>), proposed component lead</li>
<li>Thomas Guiu (<a href="http://www.soyatec.com/">Soyatec</a>), Committer</li>
</ul>

<h3>Code Contributions</h3>

It will include an initial code contribution from Soyatec. An implementation of the PMF metamodel consisting of Java packages within the org.eclipse.pmf.* namespace will be generated and customized using <a href="http://www.eclipse.org/modeling/emf/">EMF</a>.

<h3>Interested Parties</h3>

Thus far, interest in this component has been expressed by <a href="http://www.soyatec.com/">Soyatec</a>, and <a href="http://www.lyria.com/">Lyria - group W4</a>.

<h3>Developer Community</h3>

The team of initial committers will explore statements of interest from additional developers experienced with UI development and modeling or willing to gain such experience.

<h3>User Community</h3>

It is expected that the user community for this component will consist primarily of developers, given that it is essentially a foundation for building UI modeling tools.

<h2>Tentative Plan</h2>

The first major release of this component would be tentatively scheduled for June 2009, as part of the annual simultaneous release.

      </div>
  </div>
<?php
	$html = ob_get_contents();
	ob_end_clean();

	# Generate the web page
	$App->generatePage($theme, $Menu, $Nav, $pageAuthor, $pageKeywords, $pageTitle, $html);
?>
